package com.sun.xml.internal.bind.v2.model.annotation;

import com.sun.istack.internal.Nullable;
import java.lang.annotation.Annotation;
import com.sun.xml.internal.bind.v2.model.core.ErrorHandler;

public interface AnnotationReader<T, C, F, M>
{
    public abstract void setErrorHandler(ErrorHandler p0);
    
    public abstract <A extends Annotation> A getFieldAnnotation(Class<A> p0, F p1, Locatable p2);
    
    public abstract boolean hasFieldAnnotation(Class<? extends Annotation> p0, F p1);
    
    public abstract boolean hasClassAnnotation(C p0, Class<? extends Annotation> p1);
    
    public abstract Annotation[] getAllFieldAnnotations(F p0, Locatable p1);
    
    public abstract <A extends Annotation> A getMethodAnnotation(Class<A> p0, M p1, M p2, Locatable p3);
    
    public abstract boolean hasMethodAnnotation(Class<? extends Annotation> p0, String p1, M p2, M p3, Locatable p4);
    
    public abstract Annotation[] getAllMethodAnnotations(M p0, Locatable p1);
    
    public abstract <A extends Annotation> A getMethodAnnotation(Class<A> p0, M p1, Locatable p2);
    
    public abstract boolean hasMethodAnnotation(Class<? extends Annotation> p0, M p1);
    
    @Nullable
    public abstract <A extends Annotation> A getMethodParameterAnnotation(Class<A> p0, M p1, int p2, Locatable p3);
    
    @Nullable
    public abstract <A extends Annotation> A getClassAnnotation(Class<A> p0, C p1, Locatable p2);
    
    @Nullable
    public abstract <A extends Annotation> A getPackageAnnotation(Class<A> p0, C p1, Locatable p2);
    
    public abstract T getClassValue(Annotation p0, String p1);
    
    public abstract T[] getClassArrayValue(Annotation p0, String p1);
}
